const {app, BrowserWindow,Menu, Tray} = require('electron') 
const url = require('url') 
const path = require('path') 
const httpS =  require("http");
let os = require('os')
const notifier = require('node-notifier')
var AutoLaunch = require('auto-launch');


let win  
var trayIcon
var trayMenu
var minecraftAutoLauncher 

function createWindow() { 

	minecraftAutoLauncher = new AutoLaunch({
			name: 'APP',
			path: path.join(__dirname,'../../APP.exe'),
		 });
		
		 minecraftAutoLauncher.enable();
 
		 
		 minecraftAutoLauncher.isEnabled()
		.then(function(isEnabled){
			if(isEnabled){
				return;
			}
			minecraftAutoLauncher.enable();
		})
		.catch(function(err){
			console.log(err);
		});

   win = new BrowserWindow({width: 500, height: 100,show:true,webPreferences: {
            nodeIntegration: true
   }}) 
   win.loadURL(url.format ({ 
      pathname: path.join(__dirname, 'index.html'), 
      protocol: 'file:', 
      slashes: true 
   }))  
   
   win.on('closed', function () {
    win = null
  })
  
  setTimeout(function(){win.hide();},2000);

  let server = httpS.createServer(function (req, res) {
	  
	  res.setHeader('Access-Control-Allow-Origin', '*');
	  res.setHeader('Content-Type', 'application/json');
	  res.setHeader('Access-Control-Allow-Headers', 'X-Requested-With,content-type');
	  res.setHeader('Access-Control-Allow-Credentials', true);
	  
  if (req.url == '/getSysInfo') {
		return res.end(JSON.stringify({ data: getSystemInfo(),status:"200"}));
  } else {
    res.write(JSON.stringify({ msg: "Invalid url",status:"500"}));
    return res.end();
  }
	  
 }).listen(4848);
 
 
 server.on('error', function (e) {
  // Handle your error here
    notifier.notify ({
	   title: 'SAG GST',
	   message: 'Login service already running..',
	 //  icon: path.join('','/icon/images.png'),
	   sound: true,  // Only Notification Center or Windows Toasters
	   wait: false    // Wait with callback, until user action is taken 
	}, function (err, response) {
	   app.quit();
	}); 
});


        trayIcon = new Tray(path.join(__dirname,'icon/serviceIcon2.png'))

         const trayMenuTemplate = [    
            {
               label: 'Stop',
               click: function () {
                  app.quit();
               }
            }, 
         ]
         
         trayMenu = Menu.buildFromTemplate(trayMenuTemplate)
         trayIcon.setContextMenu(trayMenu)

}  
app.on('ready', createWindow);

app.on('window-all-closed', function () {
  if (process.platform !== 'darwin') {
    app.quit()
  }
})

app.on('activate', function () {
  if (mainWindow === null) {
    createWindow()
  }
}) 

 function getSystemInfo(){
	/** let josn = {};
	 josn["ipAddress"] = getIpAddress();
	 josn["platform"] = os.platform();
	 josn["arch"] = os.arch();
	 josn["hostname"] = os.hostname();
	 josn["type"] = os.type();
	 //josn["cpus"] = os.cpus();  
	 josn["homedir"] = os.homedir(); **/
	 
	 var versionString = require('child_process').execSync('ver').toString().trim();
	 
	 let obj = {};
	obj["os_name"] = versionString;
	obj["os_version"] = os.release();
	obj["sysinfo_ip"] = getIpAddress();
	obj["sysinfo_tai"] = "";
	obj["pr_sr"] = "";
	obj["mac_address"] = "";
	obj["status"] = 200;
	obj["system_name"] = os.hostname();
	obj["sysinfo_osinfo"] = os.hostname()+" - "+versionString+" - "+os.arch()+" - "+getIpAddress();

	 return obj;
 }
 
 function getIpAddress(){
				 var ipAdress = ""; 
				 var ifaces = os.networkInterfaces();
				Object.keys(ifaces).forEach(function (ifname) {
				  var alias = 0;
				  ifaces[ifname].forEach(function (iface) {
					if ('IPv4' !== iface.family || iface.internal !== false) {
					  // skip over internal (i.e. 127.0.0.1) and non-ipv4 addresses
					  return;
					}
					if (alias >= 1) {
					  // this single interface has multiple ipv4 addresses
					  //console.log(ifname + ':' + alias, iface.address);
					  ipAdress =  iface.address;
					}else {
					  // this interface has only one ipv4 adress
					  //console.log(ifname, iface.address);
					  ipAdress = iface.address;
					}
					++alias;
				  }); 
				});
				return ipAdress;
}


//electron-packager . APP --platform win32 --arch x64 --out dist/
//electron-packager . APP --platform win32 --arch ia32 --out dist/

